/*****************************************************
This program was produced by the
CodeWizardAVR V1.25.7 beta 5 Professional
Automatic Program Generator
 Copyright 1998-2007 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : 
Version : 
Date    : 08.06.2010
Author  : F4CG                            
Company : F4CG                            
Comments: 


Chip type           : ATtiny13
Clock frequency     : 4,800000 MHz
Memory model        : Tiny
External SRAM size  : 0
Data Stack size     : 16
*****************************************************/

#include <tiny13.h>
#include <delay.h>

#define OUT PORTB.2 
#define KEY PINB.4 


bit out_en=0;
int tmp,ch,cmp1,cmp2,cmp3;
char hi_byte,mode=0,tmp_del;
char buf[0x0F];
char tmp_buf,buf_cnt;
int tmp_ch;

eeprom char e_mode;


// Timer 0 output compare A interrupt service routine
interrupt [TIM0_COMPA] void timer0_compa_isr(void)
{   
//         
if ((mode==1) && (OCR0A < 250) && (out_en))OUT=1; 
}

// Timer 0 overflow interrupt service routine
interrupt [TIM0_OVF] void timer0_ovf_isr(void)
{
if (mode==1) OUT=0; //    
hi_byte++;
}


// Pin change interrupt service routine
interrupt [PCINT0] void pin_change_isr(void)
{          
// 0.833   
cmp1= ( ((int)TCNT0) + (((int)hi_byte)<<8) );
cmp2= ( ((int)TCNT0) + (((int)hi_byte)<<8) );
//   , 
if (cmp1==cmp2)cmp3=cmp1; //   -  
else cmp3= ( ((int)TCNT0) + (((int)hi_byte)<<8) );  //  - 

if (PINB.3==1)  tmp=cmp3;  // 
else            ch= cmp3 - tmp;      //  1000 - 2000  (1200-2400  )


}

void stick(void)
{             
delay_ms(400);
while (ch < 1700){};  //   
delay_ms(400);
while (ch > 1700){};  //   
}
;


//  
void blink(void)
{
  OUT=1; delay_ms(400); OUT=0; delay_ms(400);
 }
// Declare your global variables here

void main(void)
{
// Declare your local variables here

// Crystal Oscillator division factor: 1
#pragma optsize-
CLKPR=0x80;
CLKPR=0x00;
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif

// Input/Output Ports initialization
// Port B initialization
// Func5=In Func4=In Func3=In Func2=Out Func1=Out Func0=In 
// State5=T State4=P State3=P State2=0 State1=0 State0=T 
PORTB=0x18;
DDRB=0x06;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 1200,000 kHz
// Mode: Normal top=FFh
// OC0A output: Disconnected
// OC0B output: Disconnected
TCCR0A=0x00;
TCCR0B=0x02;
TCNT0=0x00;
OCR0A=0x80;
OCR0B=0x00;

// External Interrupt(s) initialization
// INT0: Off
// Interrupt on any change on pins PCINT0-5: On
GIMSK=0x20;
MCUCR=0x00;
PCMSK=0x08;
GIFR=0x20;

// Timer/Counter 0 Interrupt(s) initialization
TIMSK0=0x06;



// Global enable interrupts   

out_en=0;
delay_ms(500);    //      

#asm("sei")       
while (KEY){//    -     
         delay_ms(500);
         while (KEY)      // ,   
                {
                stick(); // //   -     
                e_mode=0;           //   
                blink();            //   - -

                stick();       
                e_mode=1;           //   - 
                blink(); 
                blink();

                stick();        
                e_mode=2;           //   - 
                blink(); 
                blink();
                blink();

                stick();   
                e_mode=3;           //  -     2 
                blink();
                blink();
                blink();
                blink();
                }
        }             

mode=e_mode; //     
delay_ms(500);    //      
ch=1200;
out_en=1;         //   
delay_ms(100);

while (1)
      {
  switch (mode)   //     (ch -      1200  2200 .)
  {
  case 0:
  if (ch>1700) OUT=1; //  - 
  else OUT=0;
  break;
  
  case 1:
  if (ch > 2300) ch=2300; if (ch < 1300) ch= 1300; //  
  buf[buf_cnt]=0xFF - (char)( (ch-1299)/4 );
  buf_cnt++;
  if (buf_cnt>0x0F)buf_cnt=0;   
  
  tmp_ch=0;
  for (tmp_buf=0;tmp_buf<0x0F;tmp_buf++){tmp_ch=tmp_ch+buf[tmp_buf];}
  
  tmp_buf=(char)(tmp_ch/0x0f);
  
  if (tmp_buf > 254) tmp_buf=254; if (tmp_buf < 1) tmp_buf= 1; //  
  OCR0A=tmp_buf; 
  delay_ms(15);
  break;
   
  case 2: 
  if (ch > 1700) {if (OUT) OUT=0; else OUT=1; delay_ms(500);} // 
  else OUT=0;
  break;
                                                                
  case 3:    //     2 
  if (ch > 1700) {tmp_del++; delay_ms(50);}
  else tmp_del=0;
  if (tmp_del > 40) {tmp_del=41; OUT=1;}
  else OUT=0;
  break;
  
  default:   //       -
  mode=0;
  e_mode=0;
  break;
  } // end switch  
      };  // end while1
} // end main
